function AdvGrid(name)
{
    this.name = name;
    this._rowsOnPage = 30;
    this._page = 1;
    this._orders = {};
    this._filters = {};
    this._urlPrefix = null;
    this._events = {};
    this._columns = [];
    this._columnsDisplayToggleCookieName = null;
    this._settings = []; //{getDialogHTML:function(){}, apply:function(){}}

    /**
     * Устаревший синоним
     */
    this.getPage=function getPage(page){
        return this.loadPage(page);
    };

    this.getCurrentPage=function getCurrentPage(){
        return this._page;
    };

    this.loadPage=function loadPage(page){
        this._page = page;
        loc.hash.setParameter(this.name+"Page", page);
        this._makeRequest();
        return false;
    };

    this.reloadPage=function reloadPage() {
        return this.loadPage(this._page);
    }

    this.setRowsOnPage = function setRowsOnPage(rowsOnPage){
        this._rowsOnPage=rowsOnPage;
    };

    this.setSavePage=function setSavePage(savePage){
        this._savePage = savePage;
    };

    this.setUrlPrefix = function setUrlPrefix(urlPrefix) {
        this._urlPrefix = urlPrefix;
    }

    this.setColumnsDisplayToggleCookieName = function setColumnsDisplayToggleCookieName(columnsDisplayToggleCookieName) {
        this._columnsDisplayToggleCookieName = columnsDisplayToggleCookieName;
    }


    this.getUrlPrefix = function getUrlPrefix() {
        return this._urlPrefix;
    };

    this.addColumn = function addColumn(column) {
        this._columns.push(column);
    };

    this.addSetting = function addSetting(setting) {
        this._settings.push(setting);
    };

    this.addEventListener = function addEventListener(ev, func)
    {
        ev = ev.toLowerCase();
        if (!this._events[ev])
            this._events[ev] = [];
        this._events[ev].push(func);
    };
    this.handleEvent = function handleEvent(ev)
    {
        ev = ev.toLowerCase();
        if (!this._events[ev]) {
            this._events[ev] = {};
            return;
        }
        for (var i = 0; i < this._events[ev].length; i++)
            this._events[ev][i](this);
    };

    /*
     *Добавляет в массив фильтров
     */
    this.addFilter = function addFilter(filter){
        this._filters[filter.getName()] = filter;
    };

    this.getFilter = function getFilter(filterName){
        return this._filters[filterName];
    };
    this.getFilters = function getFilters(){
        return this._filters;
    }

    this.getOrderBy = function getOrderBy(column) {
        return this._orders[column];
    };
    this.addOrderBy = function addOrderBy(column, order) {
        this._orders[column] = order;
    };

    this.removeOrderBy = function removeOrderBy(column) {
        delete this._orders[column];
    };

    this.removeAllOrderBy = function removeAllOrderBy() {
        this._orders = {};
    };

    /**
     * type false, "asc", "desc"
     */
    this.orderBy = function orderBy(column, order ){
        if (typeof order == "undefined"){
            order = false;
        }
        this.removeAllOrderBy();
        /*
         * Убираем ордер из списка
         */
        if (order == false){
            this.removeOrderBy(column);
        }
        else {
            this.addOrderBy(column, order);
        }

        this._makeRequest();
    };
    this.nextOrder = function nextOrder(column){
        if (this.getOrderBy(column) == "asc"){
            this.orderBy(column, 'desc');
        } else {
            this.orderBy(column, 'asc');
        }
    /*
    Трехшажная смена порядка сортировки
    if (typeof this._orders[column] == "undefined"){
        this.setOrderBy(column, 'asc');
    }else if (this._orders[column] == "asc"){
        this.setOrderBy(column, 'desc');
    }else if (this._orders[column] == "desc"){
        this.setOrderBy(column, false);
    }
    */
    };
    this._makeRequest = function _makeRequest()
	{
        var self = this;
		var url = this.getUrlPrefix() == null ? window.location.href.replace(window.location.hash, "") : this.getUrlPrefix();
        var post ={};
        post['advGridAjax'] = name;
        post[name+'RowsOnPage']=this._rowsOnPage;
        post[name+'PageNumber']=this._page;
        post[name+'OrderBy']=JSON.stringify(this._orders);
        for (var i in this._filters)
        {
            var params = this._filters[i].getProcessedParams();
            for (var j in params)
            {
                post[j] = params[j];
            }
        }
		var self = this;
        jQuery.request({
            "url": url,
            "post": post,
            "eval": true,
            "params": {
                "advGrid": self
            },
			"onBefore": function(){
				self._before();
			},
            "onSuccess": this._makeRequest_resp,
			"onComplete": function(){
				self._complete()
			}
            //"onEval": this.printPage
        });
    };

	/**
	 * Действие перед отправкой ajax-запроса
	 */
	this._before = function _before()
	{
        jQuery("#"+this.name+"_spinner").show();
    };

	/**
	 * Действие после завершения ajax-запроса
	 * (а так же после функций-обработчиков успешного (success) или аварийного (error) завершения запроса)
	 */
	this._complete = function _before()
	{
        jQuery("#"+this.name+"_spinner").hide();
    };

    this._makeRequest_resp = function _makeRequest_resp(r)
	{
        r.advGrid.printData(r.text);
        r.advGrid.onLoad();
    };

    this.onLoad = function onLoad()
	{
        this.printOrders();
        //this.printPage();
        this.callbackFilters();
        this.handleEvent("onLoad");
        var page = loc.hash.getParameter(this.name+"Page");
        var pageInt = parseInt(page);
        if (!isNaN(pageInt) && pageInt != this._page) {
            this.loadPage(pageInt);
        }
    }

    this.init = function init()
	{
        this.handleEvent("onInit");
        this.initSettings();
        this.onLoad();
    }

    this.printData = function printData(html)
	{
        this.getDesignObject().printData(html);
    };

    this.printOrders = function printOrders() {
        for (column in this._orders){
            this.getDesignObject().setOrder(column, this._orders[column]);
        }
    }

	this.printPage = function printPage(t) {
        this.getDesignObject().setPage(t._page);
    }

    this.callbackFilters = function callbackFilters() {
        for (var i in this._filters)
        {
            this._filters[i].callback();
        }
    }

    this.initSettings = function () {
        var out = "";
        for (var i in this._settings)
		{
            out += this._settings[i].getDialogHTML(this);
        }
        if(out)
            this.getDesignObject().prepareSettings(out);
    }

    this.applySettings = function () {
        for (var i in this._settings) {
            this._settings[i].apply(this);
        }
        this._makeRequest();
    }

	/**
	 * Возвращает объект, отвечающий за работу с вёрсткой
	 */
	this.getDesignObject = function()
	{
		return window[this.name+"d"];
	}
}

AdvGrid.settings = {};

AdvGrid.settings.columnHide =
{
    getDialogHTML: function(adv)
	{
        var columns = adv._columns;
        for (var i in columns)
		{
            var column = columns[i];
			var el = jQuery("#" + adv.name + "_columnDisplay_" + column.id);
			jQuery("#" + adv.name + "_columnDisplay_" + column.id + "_wrap").css("display", "block");
			if(column.toggleDisabled) JCheckBox.disabled(el);
			if(!column.hidden) {JCheckBox.visualChange(el, true)}
        }
		return "";
    },

    apply: function(adv)
	{
        var columns = adv._columns;
        var columnIds = {"hide":[], "show":[]};
        for (var i in columns)
		{
            var column = columns[i];
            var el = jQuery("#" + adv.name + "_columnDisplay_" + column.id);
            if(JCheckBox.isDisabled(el)) continue;
			if(el.prop("checked")) columnIds.show.push(column.id);
			else columnIds.hide.push(column.id);
        }
        var cookieName = adv._columnsDisplayToggleCookieName;
        if(cookieName == null)
            cookieName = adv.name + "ToggleColumns"
        cookies.set(cookieName, encodeURIComponent(JSON.stringify(columnIds)), 99);
    }
}