var loc = {
    hash : {
        _getHash : function () {
            var loc = location.hash;
            if (loc.indexOf("#") == 0) {
                loc = loc.substr(1);
            }
            return loc;
        },
        _explodeHashPairs: function (hash) {
            return hash.split("&");
        },
        _explodeHashPair: function (pair) {
            var pairArr = pair.split("=");
            var out = {
                key:null,
                value:""
            };
            if (pairArr.length > 0) {
                out.key = decodeURIComponent(pairArr[0]);
            } else {
                out.key = decodeURIComponent(pair);
            }
            if (pairArr.length > 1) {
                out.value = decodeURIComponent(pairArr[1]);
            }
            return out;
        },
        _getHashObject : function () {
            var hash = this._getHash();
            if (hash == "")
                return {};
            var pairs = this._explodeHashPairs(hash);
            var out = {};
            for (var i in pairs) {
                var pair = this._explodeHashPair(pairs[i]);
                out[pair.key] = pair.value;
            }
            return out;
        },
        _implodeHashPair: function (key, value) {
            return encodeURIComponent(key) + "=" + encodeURIComponent(value);
        },
        _implodeHashObject: function (hashObject) {
            var hashArray = [];
            for (var i in hashObject) {
                hashArray.push(this._implodeHashPair(i, hashObject[i]));
            }
            return hashArray.join("&");
        },
        _applyHashObject: function(hashObject) {
            var hash = this._implodeHashObject(hashObject);
            location.hash = hash;
        },
        getParameter : function (name) {
            var hashObject = this._getHashObject();
            return hashObject[name];
        },
        removeParameter : function (name) {
            var hashObject = this._getHashObject();
            delete hashObject[name];
            this._applyHashObject(hashObject);
        },
        setParameter : function (name, value) {
            var hashObject = this._getHashObject();
            hashObject[name] = value;
            this._applyHashObject(hashObject);
        }
    }
}