/**
 * Фон перекрывает все элементы на странице
 */

function Splash(data)
{
	data = data? data : {};

	var obj = {};
    obj._name = "";

	/**
	 * Ссылка на HTML-объект фона
	 * @type jQuery
	 */
	obj._element = null;

    /**
     * Возвращает имя объекта
     */
    obj.getName = function()
    {
        return obj._name;
    }

	/**
	 * Показывает фон и задаёт его высоту
	 */
	obj.show = function()
	{
		if(obj._element) obj._element.css({"z-index": ++JCore._static.zIndex}).show();
	}

	/**
	 * Скрывает фон
	 */
	obj.hide = function()
	{
		if(obj._element) obj._element.hide();
	}

	/**
	 * Добавляет фон в parent.
	 * Если parent не указан, то диалог добавляется в body.
	 * @param parent jQuery объект, в который диалог будет добавлен
	 */
	obj.append = function(parent)
	{
		if(!parent) parent = jQuery("body");
		if(obj._element && parent)
		{
			obj._element.appendTo(parent);
		}
		return obj;
	}

	/**
	 * Удаляет фон.
	 */
	obj.destroy = function()
	{
		if(obj._element) obj._element.detach();
		obj._element = null;
		//console.log("destroy: " + obj.getName());
	}

	/**
	 * Первоначальная инициализация фона. Создаётся HTML-объект.
	 * Фон перекрывает все элементы на странице.
	 */
	obj._init = function(initData)
	{
		obj._name = Splash._static.prefix + Splash._static.count++;
		var classNames = "class" in initData? Splash._static.prefix + " " + initData["class"] : Splash._static.prefix;
		obj._element = jQuery("<div />").attr({"id": obj._name, "class": classNames}).css("display", "none");
	}

	obj._init(data);
	window[obj.getName()] = obj;
	return obj
}

/**
 * Статичные методы и параметры
 */
Splash._static = {};
Splash._static.prefix = "JSplashBackground";
Splash._static.count = 0;
Splash._static.destroy = function()
{
	for(var i = 0; i < Splash._static.count; i++)
	{
		var el = window[Splash._static.prefix + i];
		if(!el) continue;
		el.destroy();
		window[Splash._static.prefix + i] = null;
	}
};